from math import exp
import sys

from numpy import *

import matplotlib.pyplot as pl

# init K vector of random value

num = 8
knum = 241

# print Ham
# exit()
lat_constant=1
lmd = 0.4
t_bot = 0.8
t_parallel = -0.02
gam=0.06

Ham = [[0 for i in range(num)] for j in range(num)]


Ham_soc = [[0 for i in range(num)] for j in range(num)]


def H_soc(kx,ky):
    

    Ham_soc[0][0]=lmd
    Ham_soc[0][1]=complex(0,-gam)
    Ham_soc[1][0]=complex(0,gam)
    Ham_soc[1][1]=lmd

    Ham_soc[0][2]=t_parallel*exp(complex(0, -(kx*lat_constant*1/2+ky*lat_constant*sqrt(3)/6)))*(3/4)+t_parallel*exp(complex(0, -(-kx*lat_constant*1/2+ky*lat_constant*sqrt(3)/6)))*(3/4)+t_bot*exp(complex(0, -(kx*lat_constant*1/2+ky*lat_constant*sqrt(3)/6)))*(1/4)+t_bot*exp(complex(0, -(-kx*lat_constant*1/2+ky*lat_constant*sqrt(3)/6)))*(1/4)+t_bot*exp(complex(0, -(-ky*lat_constant/sqrt(3))))
    Ham_soc[0][3]=t_parallel*exp(complex(0, -(kx*lat_constant*1/2+ky*lat_constant*sqrt(3)/6)))*(sqrt(3)/4)-t_parallel*exp(complex(0,-(-kx*lat_constant*1/2+ky*lat_constant*sqrt(3)/6)))*(sqrt(3)/4)-t_bot*exp(complex(0, -(kx*lat_constant*1/2+ky*lat_constant*sqrt(3)/6)))*(sqrt(3)/4)+t_bot*exp(complex(0, -(-kx*lat_constant*1/2+ky*lat_constant*sqrt(3)/6)))*(sqrt(3)/4)
    Ham_soc[1][2]=Ham_soc[0][3]
    Ham_soc[1][3]=t_parallel*exp(complex(0, -(kx*lat_constant*1/2+ky*lat_constant*sqrt(3)/6)))*(1/4)+t_parallel*exp(complex(0, -(-kx*lat_constant*1/2+ky*lat_constant*sqrt(3)/6)))*(1/4)+t_bot*exp(complex(0, -(kx*lat_constant*1/2+ky*lat_constant*sqrt(3)/6)))*(3/4)+t_bot*exp(complex(0, -(-kx*lat_constant*1/2+ky*lat_constant*sqrt(3)/6)))*(3/4)+t_parallel*exp(complex(0, -(-ky*lat_constant/sqrt(3))))

    Ham_soc[2][0]=conj(Ham_soc[0][2])
    Ham_soc[2][1]=conj(Ham_soc[1][2])
    Ham_soc[3][0]=conj(Ham_soc[0][3])
    Ham_soc[3][1]=conj(Ham_soc[1][3])

    Ham_soc[2][2]=-lmd
    Ham_soc[2][3]=complex(0,-gam)
    Ham_soc[3][2]=complex(0,gam)
    Ham_soc[3][3]=-lmd



    Ham_soc[0+4][0+4]=lmd
    Ham_soc[0+4][1+4]=complex(0,gam)
    Ham_soc[1+4][0+4]=complex(0,-gam)
    Ham_soc[1+4][1+4]=lmd

    Ham_soc[4][6]=t_parallel*exp(complex(0, -(kx*lat_constant*1/2+ky*lat_constant*sqrt(3)/6)))*(3/4)+t_parallel*exp(complex(0, -(-kx*lat_constant*1/2+ky*lat_constant*sqrt(3)/6)))*(3/4)+t_bot*exp(complex(0, -(kx*lat_constant*1/2+ky*lat_constant*sqrt(3)/6)))*(1/4)+t_bot*exp(complex(0, -(-kx*lat_constant*1/2+ky*lat_constant*sqrt(3)/6)))*(1/4)+t_bot*exp(complex(0, -(-ky*lat_constant/sqrt(3))))
    Ham_soc[0+4][3+4]=t_parallel*exp(complex(0, -(kx*lat_constant*1/2+ky*lat_constant*sqrt(3)/6)))*(sqrt(3)/4)-t_parallel*exp(complex(0,-(-kx*lat_constant*1/2+ky*lat_constant*sqrt(3)/6)))*(sqrt(3)/4)-t_bot*exp(complex(0, -(kx*lat_constant*1/2+ky*lat_constant*sqrt(3)/6)))*(sqrt(3)/4)+t_bot*exp(complex(0, -(-kx*lat_constant*1/2+ky*lat_constant*sqrt(3)/6)))*(sqrt(3)/4)
    Ham_soc[1+4][2+4]=Ham_soc[0][3]
    Ham_soc[1+4][3+4]=t_parallel*exp(complex(0, -(kx*lat_constant*1/2+ky*lat_constant*sqrt(3)/6)))*(1/4)+t_parallel*exp(complex(0, -(-kx*lat_constant*1/2+ky*lat_constant*sqrt(3)/6)))*(1/4)+t_bot*exp(complex(0, -(kx*lat_constant*1/2+ky*lat_constant*sqrt(3)/6)))*(3/4)+t_bot*exp(complex(0, -(-kx*lat_constant*1/2+ky*lat_constant*sqrt(3)/6)))*(3/4)+t_parallel*exp(complex(0, -(-ky*lat_constant/sqrt(3))))

    Ham_soc[2+4][0+4]=conj(Ham_soc[0+4][2+4])
    Ham_soc[2+4][1+4]=conj(Ham_soc[1+4][2+4])
    Ham_soc[3+4][0+4]=conj(Ham_soc[0+4][3+4])
    Ham_soc[3+4][1+4]=conj(Ham_soc[1+4][3+4])

    Ham_soc[2+4][2+4]=-lmd
    Ham_soc[2+4][3+4]=complex(0,gam)
    Ham_soc[3+4][2+4]=complex(0,-gam)
    Ham_soc[3+4][3+4]=-lmd

    e, w = linalg.eig(Ham_soc)
    e = [real(e[y]) for y in range(num)]
    e = sort(e)
    print(e)
    return e


ens = zeros((num, knum), dtype=float64)
a1 = open("kpoints1", 'r+')
for m in range(knum):
    Kq = a1.readline().strip().split()
    kx,ky=[float(Kq[n]) for n in range(2)]
    e=H_soc(kx,ky)
    for y in range(num):
        ens[y, m] = real(e[y])
print(ens)

pl.figure(figsize=(16.0, 12.4))
pl.subplots_adjust(wspace=0.35)
pl.ylim(-2, 2)
pl.xlim(0, knum)
pl.grid(True)

# print(nOrbits)
for i in range(num):
    # print i
    # pl.plot(ens[i], 'go', ms=5, mew=1)
    pl.plot(ens[i], 'g-', ms=5, mew=1)
    # pl.plot(evals[i], 'ro', ms=5, mew=1)

# pl.plot(ens[4], 'go', ms=5, mew=1)
pl.title(r'$\Gamma$')

pl.ylabel("Energy")

# my_array = wf_array(my_model, [41, 41, 2])

# my_array.solve_on_grid([-0.5, -0.5, 0])

# for i in range(nOrbits):
#     curv_a_1 = my_array.berry_flux([i])
#     print "%d C= %f" % (i+1, curv_a_1[0]/np.pi/2.0)

pl.show()

print('Done.\n')
